//
//                      Copyright (c) 1996 by
//                      Advanced Visual Systems Inc.
//                      All Rights Reserved
//
//      This software comprises unpublished confidential information of
//      Advanced Visual Systems Inc. and may not be used, copied or made
//      available to anyone, except in accordance with the license
//      under which it is furnished.
//
//      This file is under Perforce control
//      $Id: //depot/express/fcs72/runtime/nls/ja_JP/fonts.v#1 $
//
//  fonts.v - Font definitions for ja_JP locale
//
//---------------------------------------------------------------------//

group WTfonts {

    WTfontFamilyList default {
       families = {
#ifdef WIN32
        { family = "SVbNaaa", charset = "SHIFTJIS_CHARSET" }
#else
        { family = "*-fixed-medium-r-normal--14", charset = "JISX0208.1983-0" },
        { family = "*-fixed-medium-r-normal--14", charset = "JISX0208.1976-0" },
        { family = "*-courier",  charset = "ISO8859-1" }
#endif
       };
    };

    WTfontFamilyList courier {
       families = {
#ifdef WIN32
        { family =   "courier new", charset = "SHIFTJIS_CHARSET" }
#else
        { family = "*-fixed-medium-r-normal--14", charset = "JISX0208.1983-0" },
        { family = "jis-fixed",  charset = "JISX0208.1983-0" },
        { family = "misc-fixed", charset = "JISX0201.1976-0" },
        { family = "*-fixed",    charset = "JISX0201.1976-0" },
        { family = "*-courier",  charset = "ISO8859-1" }
#endif
        };
    };

    WTfontFamilyList times {
       families = {
#ifdef WIN32
        { family =   "times new roman", charset = "SHIFTJIS_CHARSET" }
#else
        { family = "*-fixed-medium-r-normal--14", charset = "JISX0208.1983-0" },
        { family = "jis-fixed",  charset = "JISX0208.1983-0" },
        { family = "misc-fixed", charset = "JISX0201.1976-0" },
        { family = "*-fixed",    charset = "JISX0201.1976-0" },
        { family = "*-times",    charset = "ISO8859-1" }
#endif
       };
    };

    WTfontFamilyList gothic {
       families = {
#ifdef WIN32
        { family = "lr SVbN", charset = "SHIFTJIS_CHARSET" }
#else
        { family = "*-gothic",   charset = "JISX0208.1983-0" },
        { family = "*-gothic",   charset = "JISX0208.1983-1" }
#endif
       };
    };
    WTfontFamilyList mincho {
       families = {
#ifdef WIN32
        { family = "lr ", charset = "SHIFTJIS_CHARSET" }
#else
        { family = "*-mincho",   charset = "JISX0208.1983-0" },
        { family = "*-mincho",   charset = "JISX0208.1983-1" }
#endif
       };
    };

};

//---------------------------------------------------------------------//
//                         End of fonts.v                              //
//---------------------------------------------------------------------//
